<template>
  <q-list class="rounded-borders">
    <q-item clickable v-ripple>
      <q-item-section avatar>
        <q-avatar icon="mdi-developer-board" />
      </q-item-section>
      <q-item-section class="nunito text-body1">Testbed</q-item-section>
      <q-item-section side>
        <q-chip
          text-color="white"
          :color="switchColor(treeView.testbed)"
          :label="switchLabel(treeView.testbed)"
          :icon="switchIcon(treeView.testbed)"
        />
      </q-item-section>
    </q-item>
    <q-item clickable v-ripple>
      <q-item-section avatar>
        <q-avatar icon="mdi-export" />
      </q-item-section>
      <q-item-section class="nunito text-body1">Controllers</q-item-section>
      <q-item-section side>
        <q-chip
          text-color="white"
          :color="switchColor(treeView.controllers)"
          :label="switchLabel(treeView.controllers)"
          :icon="switchIcon(treeView.controllers)"
        />
      </q-item-section>
    </q-item>
    <q-item clickable v-ripple>
      <q-item-section avatar>
        <q-avatar icon="mdi-sine-wave" />
      </q-item-section>
      <q-item-section class="nunito text-body1">References</q-item-section>
      <q-item-section side>
        <q-chip
          text-color="white"
          :color="switchColor(treeView.references)"
          :label="switchLabel(treeView.references)"
          :icon="switchIcon(treeView.references)"
        />
      </q-item-section>
    </q-item>
  </q-list>
</template>

<script lang="ts">
import { defineComponent, PropType, computed, reactive, ref } from 'vue';
import { Scene } from 'src/models/workflow';
import { EnumStatus } from './utils';
import { RefinedBlock } from 'src/models/workflow';
import { scene2task } from 'src/components/task/tree';

interface Status {
  testbed: EnumStatus;
  controllers: EnumStatus;
  references: EnumStatus;
}

export default defineComponent({
  props: {
    scene: {
      type: Object as PropType<Scene>,
      default: {
        nodes: [],
        blocks: [],
        links: [],
        container: {
          center: { x: 0, y: 0 },
          scale: 1,
        },
      } as Scene,
    },
  },
  setup(props) {
    const isReady = (block: RefinedBlock) => {
      if (Object.values(block.data).length === 0) return true;
      return Object.values(block.data).every((parameter) => parameter != null && parameter.toString().length !== 0);
    };
    const treeView = computed(() => {
      const rawTask = scene2task(props.scene);
      const status: Status = reactive({
        testbed: EnumStatus.MISSING,
        controllers: EnumStatus.MISSING,
        references: EnumStatus.MISSING,
      });

      if (rawTask.testbed) {
        if (isReady(rawTask.testbed)) status.testbed = EnumStatus.READY;
        else status.testbed = EnumStatus.ERROR;
      } else status.testbed = EnumStatus.MISSING;

      if (status.testbed !== EnumStatus.MISSING) {
        let total = EnumStatus.READY;
        Object.keys(rawTask.controllers).forEach((key) => {
          const controller = rawTask.controllers[key];
          let temp = EnumStatus.MISSING;
          if (controller) {
            if (isReady(controller)) temp = EnumStatus.READY;
            else temp = EnumStatus.ERROR;
          } else temp = EnumStatus.MISSING;
          if (temp < total) total = temp;
        });
        status.controllers = total;
        total = EnumStatus.READY;
        Object.keys(rawTask.references).forEach((key) => {
          const reference = rawTask.references[key];
          let temp = EnumStatus.MISSING;
          if (reference) {
            if (isReady(reference)) temp = EnumStatus.READY;
            else temp = EnumStatus.ERROR;
          } else temp = EnumStatus.MISSING;
          if (temp < total) total = temp;
        });
        status.references = total;
      }

      return status;
    });

    const switchColor = (e: EnumStatus) => {
      switch (e) {
        case EnumStatus.ERROR:
          return 'red-9';
        case EnumStatus.READY:
          return 'teal';
        default:
        case EnumStatus.MISSING:
          return 'grey';
      }
    };

    const switchIcon = (e: EnumStatus) => {
      switch (e) {
        case EnumStatus.ERROR:
          return 'warning';
        case EnumStatus.READY:
          return 'done';
        default:
        case EnumStatus.MISSING:
          return 'help';
      }
    };

    const switchLabel = (e: EnumStatus) => {
      switch (e) {
        case EnumStatus.ERROR:
          return 'Error';
        case EnumStatus.READY:
          return 'Ready';
        default:
        case EnumStatus.MISSING:
          return 'Missing';
      }
    };

    return {
      treeView,
      switchColor,
      switchIcon,
      switchLabel,
    };
  },
});
</script>
